<template>
  <div class="UI-dynamic" :id="'UI-dynamic-'+areasName+componentVO.oid">
    <u-i-content-viewer-in-dialog
      :btmType="btmType"
      :context="context"
      :inDialog="true"
      :key="areasName+'customCom-'+componentVO.oid"
      :componentVO="componentVO"
      :sourceData="sourceData"
      :dataStore="dataStore"
      :areasName="areasName"
      :paramVOS="urlParams"
      @setData="setData"
      @setDataStore="setDataStore">
    </u-i-content-viewer-in-dialog>
  </div>
</template>

<script>
import {queryStringToObject} from '@/util/util'
import UIContentViewerInDialog from "@/views/base/UIContentViewerInDialog";
export default {
  name: "dynamic-uiParse",
  components: {UIContentViewerInDialog},
  props: {
    //ui上下文的业务类型（或链接类型）
    uiBtmType: {
      type: String
    },
    //ui上下文
    uiContext:{
      type: String
    },
    componentVO: {
      type: Object,
      default: {}
    },
    inDialog: {
      type: Boolean,
      default: false
    },
    canEdit:{
      //内容是否可编辑
      type:Boolean,
      default:false
    },
    areasName: {
      type: String,
      default: ''
    },
    sourceData: {
      //所属区域的上一区域选中数据
      type: Object,
      default: {}
    },
    dataStore: {
      //弹窗时按钮所属区域选中数据
      type: Array,
      default: []
    },
    paramVOS: {
      type: Object,
      default: {}
    },
    isShow: {
      //所在区域是否已显示，针对tab和collapse
      type: Boolean,
      default: true
    },
  },
  data() {
    return {
      btmType: '',
      context: '',
      urlParams: {},
      height: '300px',
      uiParseClass: '', //?type=xxx&context=yyy&param=zzz
      isError: false, //路径解析失败
      ComponentUrl:'base/UIContentViewerInDialog',
      currentComponent: null
    }
  },
  watch: {
    sourceData:{
      handler(newval) {
        //源数据有变化时变更当前区域数据
        this.sourceDataMap();
      },
      deep: true,
      immediate: true
    }
  },
  computed: {},
  created() {
    this.sourceDataMap();
  },
  mounted() {
    //this.getHeight(this.$parent);
  },
  methods: {
    sourceDataMap: function () {
      this.uiParseClass=this.componentVO.uiParseClass;
      let urlParams = {};
      // 如果路径中存在 '?'
      if (this.uiParseClass.includes('?')) {
        urlParams = queryStringToObject(this.customClass);
      }

      this.btmType = urlParams.type;
      this.context = urlParams.context;
      this.urlParams = Object.assign({},this.paramVOS, urlParams)
    },
    getHeight(el) {
      if (el.$el.clientHeight > 50) {
        this.height = el.$el.clientHeight + 'px';
      } else {
        this.getHeight(el.$parent);
      }
    },
    setDataStore(value) {
      this.$emit("setDataStore", value);
      this.dataStore = value.dataStore;
    },
    setData(value) {
      this.$emit("setData", value);
    }
  }
}
</script>

<style scoped lang="scss">

</style>

